﻿Imports System.Configuration
Imports System.Data
Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            BindUserDetails1()
        End If
    End Sub

    Protected Sub BindUserDetails1()
        Dim constr1 As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con1 As SqlConnection = New SqlConnection(constr1)
            Using sda1 As SqlDataAdapter = New SqlDataAdapter("SELECT * from cylinder", con1)
                Using dt1 As DataTable = New DataTable()
                    sda1.Fill(dt1)
                    avDetails.DataSource = dt1
                    avDetails.DataSource = dt1
                    avDetails.DataBind()
                End Using
            End Using
        End Using
    End Sub

    Private Function GetAcceptedCylinder(ByVal pid As String) As String
        Dim acceptCylinder As String = ""
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString

        Using con As SqlConnection = New SqlConnection(constr)

            Using cmd As SqlCommand = New SqlCommand()
                cmd.CommandText = "SELECT cylinders FROM issuesheet WHERE pid=@pid "
                cmd.Connection = con
                cmd.Parameters.AddWithValue("@pid", pid)
                con.Open()
                acceptCylinder = Convert.ToString(cmd.ExecuteScalar())
                con.Close()
            End Using
        End Using

        Return acceptCylinder
    End Function

    Protected Sub OnRowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim id As String = e.Row.Cells(2).Text
            Dim cylinders As String() = GetAcceptedCylinder(id).Replace("[", "").Replace("]", "").Split(","c)
            Dim chkSelect As CheckBox = TryCast(e.Row.FindControl("chkSelect"), CheckBox)

            If cylinders.Contains("'" & e.Row.Cells(1).Text & "'") Then
                chkSelect.Checked = True
            Else
                chkSelect.Checked = False
            End If
        End If
    End Sub

    Protected Sub OnChckedChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim chk As CheckBox = CType(sender, CheckBox)
        Dim row As GridViewRow = CType(chk.NamingContainer, GridViewRow)
        Dim number As String = row.Cells(1).Text
        Dim pid As String = "206"
        Dim constring As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(constring)
            Dim acceptedCylinder As String = GetAcceptedCylinder(pid)
            If chk.Checked Then
                If acceptedCylinder = "[]" Then
                    Using cmd As SqlCommand = New SqlCommand("UPDATE issuesheet SET cylinders = @cylinders where pid='206'", con)
                        cmd.Parameters.AddWithValue("@cylinders", "['" & number.Trim() & "']")
                        con.Open()
                        cmd.ExecuteNonQuery()
                        con.Close()
                    End Using
                    ClientScript.RegisterStartupScript(Me.[GetType](), "Popup", "ShowPopup('Record Inserted successfully.');", True)
                Else
                    Dim cylinderNo As List(Of String) = acceptedCylinder.Replace("[", "").Replace("]", "").Replace("'", "").Split(","c).ToList()
                    cylinderNo.Add(number)

                    Using cmd As SqlCommand = New SqlCommand("UPDATE issuesheet SET cylinders = @cylinders where pid='206'", con)
                        cmd.Parameters.AddWithValue("@cylinders", "['" & String.Join("','", cylinderNo.Distinct()) & "']")
                        con.Open()
                        cmd.ExecuteNonQuery()
                        con.Close()
                    End Using
                    ClientScript.RegisterStartupScript(Me.[GetType](), "Popup", "ShowPopup('Record Updated Successfully.');", True)
                End If
            Else

                If Not String.IsNullOrEmpty(acceptedCylinder) Then
                    Dim cylinderNo As List(Of String) = acceptedCylinder.Replace("[", "").Replace("]", "").Replace("'", "").Split(","c).ToList()
                    cylinderNo.Remove(number)

                    Using cmd As SqlCommand = New SqlCommand("UPDATE issuesheet SET cylinders = @cylinders where pid='206' ", con)
                        cmd.Parameters.AddWithValue("@cylinders", If(cylinderNo.Distinct().Count() > 0, "['" & String.Join("','", cylinderNo.Distinct()) & "']", "[]"))
                        con.Open()
                        cmd.ExecuteNonQuery()
                        con.Close()
                    End Using

                    ClientScript.RegisterStartupScript(Me.[GetType](), "Popup", "ShowPopup('Record Deleted Successfully.');", True)
                End If
            End If
        End Using
    End Sub


End Class
