﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            BindUserDetails1();
        }
    }

    protected void BindUserDetails1()
    {
        string constr1 = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con1 = new SqlConnection(constr1))
        {
            using (SqlDataAdapter sda1 = new SqlDataAdapter("SELECT * from cylinder", con1))
            {

                using (DataTable dt1 = new DataTable())
                {
                    sda1.Fill(dt1);
                    avDetails.DataSource = dt1;
                    avDetails.DataSource = dt1;
                    avDetails.DataBind();
                }
            }
        }
    }

    private string GetAcceptedCylinder(string pid)
    {
        string acceptCylinder = "";
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT cylinders FROM issuesheet WHERE pid=@pid ";
                cmd.Connection = con;
                cmd.Parameters.AddWithValue("@pid", pid);
                con.Open();
                acceptCylinder = Convert.ToString(cmd.ExecuteScalar());
                con.Close();
            }
        }

        return acceptCylinder;
    }

    protected void OnRowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            string id = e.Row.Cells[2].Text;
            string[] cylinders = GetAcceptedCylinder(id).Replace("[", "").Replace("]", "").Split(',');
            CheckBox chkSelect = e.Row.FindControl("chkSelect") as CheckBox;
            if (cylinders.Contains("'" + e.Row.Cells[1].Text + "'"))
            {
                chkSelect.Checked = true;
            }
            else
            {
                chkSelect.Checked = false;
            }
        }
    }

    protected void OnChckedChanged(object sender, EventArgs e)
    {
        ClientScript.RegisterStartupScript(this.GetType(), "Popup", "ShowPopup('Record Updated Successfully.');", true);
        //CheckBox chk = (CheckBox)sender;
        //GridViewRow row = (GridViewRow)chk.NamingContainer;

        //string number = row.Cells[1].Text;
        //string pid = "206";

        //string constring = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        //using (SqlConnection con = new SqlConnection(constring))
        //{
        //    string acceptedCylinder = GetAcceptedCylinder(pid);
        //    if (chk.Checked)
        //    {
        //        if (acceptedCylinder == "[]")
        //        {
        //            using (SqlCommand cmd = new SqlCommand("UPDATE issuesheet SET cylinders = @cylinders where pid='206'", con))
        //            {
        //                cmd.Parameters.AddWithValue("@cylinders", "['" + number.Trim() + "']");
        //                con.Open();
        //                cmd.ExecuteNonQuery();
        //                con.Close();
        //            }
        //            ClientScript.RegisterStartupScript(this.GetType(), "Popup", "ShowPopup('Record Inserted successfully.');", true);
        //        }
        //        else
        //        {
        //            List<string> cylinderNo = acceptedCylinder.Replace("[", "").Replace("]", "").Replace("'", "").Split(',').ToList();
        //            cylinderNo.Add(number);
        //            using (SqlCommand cmd = new SqlCommand("UPDATE issuesheet SET cylinders = @cylinders where pid='206'", con))
        //            {
        //                cmd.Parameters.AddWithValue("@cylinders", "['" + string.Join("','", cylinderNo.Distinct()) + "']");
        //                con.Open();
        //                cmd.ExecuteNonQuery();
        //                con.Close();
        //            }
        //            ClientScript.RegisterStartupScript(this.GetType(), "Popup", "ShowPopup('Record Updated Successfully.');", true);
        //        }
        //    }
        //    else
        //    {
        //        if (!string.IsNullOrEmpty(acceptedCylinder))
        //        {
        //            List<string> cylinderNo = acceptedCylinder.Replace("[", "").Replace("]", "").Replace("'", "").Split(',').ToList();
        //            cylinderNo.Remove(number);
        //            using (SqlCommand cmd = new SqlCommand("UPDATE issuesheet SET cylinders = @cylinders where pid='206' ", con))
        //            {
        //                cmd.Parameters.AddWithValue("@cylinders", cylinderNo.Distinct().Count() > 0 ? "['" + string.Join("','", cylinderNo.Distinct()) + "']" : "[]");
        //                con.Open();
        //                cmd.ExecuteNonQuery();
        //                con.Close();
        //            }
        //            ClientScript.RegisterStartupScript(this.GetType(), "Popup", "ShowPopup('Record Deleted Successfully.');", true);
        //        }
        //    }
        //}
    }
}